main()
{
	//maps\mp\mp_islands_fx::main();
	//maps\createart\mp_islands_art::main();
	maps\mp\_load::main();	
	
	maps\mp\_compass::setupMiniMap("compass_map_mp_islands");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_islands" );
	ambientPlay("ambient_factory_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar("r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	//fx
	level.fx_splash = loadfx("explosions/grenadeexp_water");

	//fog code
	setExpFog(3000, 5000, 1, 1, 1, 0.0);

	//water_tread_bottom code
	water_tread_bottom = getent("water_tread_bottom","targetname");
	water_tread_bottom thread water_tread_bottom_bob();

	//water code
	trig_water_under = getent("water_under","targetname");
	trig_water_surface = getent("water_surface","targetname");
	trig_water_under thread water_under();
	trig_water_surface thread water_surface();

	//teleport code
	trig_teleport = getentarray("trig_teleport","targetname");
	for(i=0;i<trig_teleport.size;i++)
	{
		trig_teleport[i].destination = getent(trig_teleport[i].target, "targetname");
		trig_teleport[i] thread teleport();
		trig_teleport[i] thread teleport_fx_begin();
	}
}


//teleport code
teleport_fx_begin()
{
	self.height_small = 16;
	self.height_big = 48;
	if (self.script_noteworthy == "color0")
	{
		level._effect["teleport_blue_small"] = loadfx("misc/teleport_blue_small");
		maps\mp\_fx::loopfx("teleport_blue_small", (self.origin + (0, 0, self.height_small)), 0.5);
		level._effect["teleport_blue_big"] = loadfx("misc/teleport_blue_big");
		maps\mp\_fx::loopfx("teleport_blue_big", (self.destination.origin + (0, 0, self.height_big)), 0.5);	
	}
	else if (self.script_noteworthy == "color1")
	{
		level._effect["teleport_red_small"] = loadfx("misc/teleport_red_small");
		maps\mp\_fx::loopfx("teleport_red_small", (self.origin + (0, 0, self.height_small)), 0.5);
		level._effect["teleport_red_big"] = loadfx("misc/teleport_red_big");
		maps\mp\_fx::loopfx("teleport_red_big", (self.destination.origin + (0, 0, self.height_big)), 0.5);	
	}
	else if (self.script_noteworthy == "color2")
	{
		level._effect["teleport_green_small"] = loadfx("misc/teleport_green_small");
		maps\mp\_fx::loopfx("teleport_green_small", (self.origin + (0, 0, self.height_small)), 0.5);
		level._effect["teleport_green_big"] = loadfx("misc/teleport_green_big");
		maps\mp\_fx::loopfx("teleport_green_big", (self.destination.origin + (0, 0, self.height_big)), 0.5);	
	}
	else if (self.script_noteworthy == "color3")
	{
		level._effect["teleport_pink_small"] = loadfx("misc/teleport_pink_small");
		maps\mp\_fx::loopfx("teleport_pink_small", (self.origin + (0, 0, self.height_small)), 0.5);
		level._effect["teleport_pink_big"] = loadfx("misc/teleport_pink_big");
		maps\mp\_fx::loopfx("teleport_pink_big", (self.destination.origin + (0, 0, self.height_big)), 0.5);	
	}
	else if (self.script_noteworthy == "color4")
	{
		level._effect["teleport_yellow_small"] = loadfx("misc/teleport_yellow_small");
		maps\mp\_fx::loopfx("teleport_yellow_small", (self.origin + (0, 0, self.height_small)), 0.5);
		level._effect["teleport_yellow_big"] = loadfx("misc/teleport_yellow_big");
		maps\mp\_fx::loopfx("teleport_yellow_big", (self.destination.origin + (0, 0, self.height_big)), 0.5);	
	}
}


teleport()
{
	while (1)
	{
		self waittill("trigger", user);
		user setorigin(self.destination.origin);
		wait(0.1);
		user playlocalsound("teleport");
		wait(0.1);
	}
}

//water_tread_bottom code
water_tread_bottom_bob()
{
	water_tread_bottom_time = 1;
	water_tread_bottom_distance = 4;
	while (true)
	{
		self movez(water_tread_bottom_distance, water_tread_bottom_time, 0.5 * water_tread_bottom_time, 0.5 * water_tread_bottom_time);
		self waittill ("movedone");
		self movez(-1 * water_tread_bottom_distance, water_tread_bottom_time, 0.5 * water_tread_bottom_time, 0.5 * water_tread_bottom_time);
		self waittill ("movedone");
	}
}

//water_under code
water_under()
{
	while (1)
	{
		self waittill("trigger", user);
		user.water_under_exit_count = 0;	
		if (!isdefined(user.under_in))
		{
			user.under_in = false;
		}
		if (!user.under_in)
		{
			user.under_in = true;
			self thread water_under_exit_count_loop(user);
			self thread water_under_enter(user);
		}
	}
}

water_under_enter(user)
{
}

water_under_exit(user)
{
}

water_under_exit_count_loop(user)
{
	while (user.water_under_exit_count < 3)
	{
		user.water_under_exit_count++;
		if (user.under_in && !user.surface_in)
		{
			user.water_under_count++;
			if (user.water_under_count > user.water_hurt_wait * 10)
			{
				user.water_under_count = user.water_hurt_wait * 10;
				RadiusDamage(user.origin, 1, 2, 2);
			}
		}
		wait(0.1);
	}
	user.under_in = false;
	self thread water_under_exit(user);
}


//water_surface code
water_surface()
{
	while (1)
	{
		self waittill("trigger", user);
		user.water_surface_exit_count = 0;	
		if (!isdefined(user.surface_in))
		{
			user.surface_in = false;
			user.under_in = false;
			user.water_under_count = 0;
			user.water_hurt_wait = 5;
		}
		if (!user.surface_in)
		{
			user.surface_in = true;
			self thread water_surface_exit_count_loop(user);
			self thread water_surface_enter(user);
		}
	}
}

water_surface_enter(user)
{
	user.water_under_count = 0;
	user.water_under_exit_count = 0;
	if (!user.under_in)
	{
		PlayFX(level.fx_splash, user.origin);
	}
	user playsound("watersplash");
	user stoplocalsound("waterbackground");
}

water_surface_exit(user)
{
	if (user.under_in)
	{
		user playlocalsound("waterbackground");
	}
}

water_surface_exit_count_loop(user)
{
	while (user.water_surface_exit_count < 3)
	{
		user.water_surface_exit_count++;
		wait(0.1);
	}
	user.surface_in = false;
	self thread water_surface_exit(user);
}